package ids;

import ids.*;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.DocumentBuilder;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;
import org.w3c.dom.Document;
import javax.swing.*;
import javax.swing.tree.*;
import javax.swing.event.*;
import java.io.*;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import java.io.*;

class AdapterNode {

    static final String[] typeName = {
        "none",
        "Element",
        "Attr",
        "Text",
        "CDATA",
        "EntityRef",
        "Entity",
        "ProcInstr",
        "Comment",
        "Document",
        "DocType",
        "DocFragment",
        "Notation",
    };

        org.w3c.dom.Node domNode;

        public AdapterNode(org.w3c.dom.Node node) {
            domNode = node;
        }

        public String toString() {
            String s = typeName[domNode.getNodeType()];
            String nodeName = domNode.getNodeName();
            if (nodeName.equals("SIGNATURE")) {
                nodeName += " " +
                    domNode.getAttributes().getNamedItem("ID").getNodeValue();
            }
            if (!nodeName.startsWith("#")) {
                s += ": " + nodeName;
            }
            if (domNode.getNodeValue() != null) {
                if (s.startsWith("ProcInstr"))
                    s += ", ";
                else
                    s += ": ";
                String t = domNode.getNodeValue().trim();
                int x = t.indexOf("\n");
                if (x >= 0)
                    t = t.substring(0, x);
                s += t;
            }
            return s;
        }

        /*
         * Return	children, index, and count values
         */
        public int index(AdapterNode child) {

            int count = childCount();
            for (int i = 0; i < count; i++) {
                AdapterNode n = this.child(i);
                if (child.domNode == n.domNode)
                    return i;
            }
            return -1;
        }

        public AdapterNode child(int searchIndex) {

            org.w3c.dom.Node node = domNode.getChildNodes().item(searchIndex);
            return new AdapterNode(node);
        }

        public int childCount() {

            return domNode.getChildNodes().getLength();
        }
    }
	