package ids;

import javax.swing.*;

public
class DragonSignature extends AnySignature{

    public String string;

    public char protocol;               //T-TCP, U-UDP, I-ICMP
    public char port_direction;         //D-destination, S-source, A-all, B-both
    public char prot_net_direct;        //A-any, T-to, F-from, I-to and from, X-none, D-dynamically
    public char pattern_type;           //B-binnary, S-string
    public int log_numbers;             //number of packets logged in after event
    public int search_depth;            //number of bytes of packets
    public String port_numbers;         //port number or coplex list (L-? W-Web)
    public String name;                 //message send to administrator
    public String pattern;              // pattern we are looking for
    public String pattern_hex;          // pattern we are looking for (in hex code)
    public boolean success;
    public String result = "";
    public String description = "";

        public char switchString(String expr, String[] args) {
              if (args.length % 2 != 0)
                    return 0;
              for (int i = 0; i < args.length; i += 2)
                    if (expr.equals(args[i]))
                          return args[i + 1].charAt(0);
              return 0;
        }
        public String switchChar(char expr, String[] args) {
              if (args.length % 2 != 0)
                    return null;
              for (int i = 0; i < args.length; i += 2)
                    if (expr == args[i].charAt(0))
                          return args[i + 1];
              return null;
        }


    public DragonSignature(CommonSignature cs){


        // ******************* protocol ********************** //
                String str[] = {"tcp","T","udp","U","icmp","I"};
                protocol = switchString(cs.protocol.toLowerCase(),str);
                if(protocol == 0){
                      result = "Dragon constructor: Unknown protocol. FAILED";
                      return;
                }

        // **************** ports (direction and numbers) ***** //
        if(cs.source_port.equals("any") && cs.destination_port.equals("any")){
            port_direction = 'A';
            port_numbers = cs.source_port;
        }
        else if(!(cs.source_port).equals("any") && !(cs.destination_port).equals("any") && cs.destination_port == cs.source_port){
            port_direction = 'B';
            port_numbers = cs.source_port;
        }
        else if(!(cs.source_port).equals("any")){
            port_direction = 'S';
            port_numbers = cs.source_port;
        }
        else if(!(cs.destination_port).equals("any")){
            port_direction = 'D';
            port_numbers = cs.destination_port;
        }
        else{
            port_numbers = JOptionPane.showInputDialog(null, "Enter port number");
            port_direction = (JOptionPane.showInputDialog(null, "D - destination \nS - source \nA - any \nB - both (source and destination)")).charAt(0);
        }


        // ************** IP ****************************** //

        if((cs.source_ip).equals("any") && (cs.destination_ip).equals("any"))
            prot_net_direct = 'A';
        else if((cs.source_ip).equals("$EXTERNAL_NET") && (cs.destination_ip).equals("$HOME_NET"))
            prot_net_direct = 'T';
        else if((cs.source_ip).equals("$HOME_NET") && (cs.destination_ip).equals("$EXTERNAL_NET"))
            prot_net_direct = 'F';
        else if((cs.source_ip).equals("$HOME_NET") && (cs.destination_ip).equals("$HOME_NET"))
            prot_net_direct = 'I';
        else if((cs.source_ip).equals("$EXTERNAL_NET") && (cs.destination_ip).equals("$EXTERNAL_NET"))
            prot_net_direct = 'X';
        else{
            JOptionPane.showMessageDialog(
                null, "\n		You cannot write specific IP numbers in Dragon\n       " +
                      "		so \"protected network direction\" is set to 'A'\n\n", "WARNING",
                      JOptionPane.WARNING_MESSAGE);
            prot_net_direct = 'A';
        }


        // ************* pattern_type ********************** //
        if(cs.pattern_type == null){
            result = "Dragon constructor: null pattern_type, String pattern_type set";
            pattern_type = 'S';
        }
        else{
                        String str2[] = {"string","S","binary","B"};
                        pattern_type = switchString(cs.pattern_type,str2);
                        if(pattern_type == 0){
                result = "Dragon constructor: Unknown pattern_type type";
                return;
                        }
        }

        // ************ log numbers ******************** //
        log_numbers = cs.loged_packets;

        // ************ search depth ******************* //
        search_depth = cs.search_depth;

        // ************ message text ******************* //
        name = 	replaceAll(cs.message," ","/20");

        // ************ message text ******************* // TODO: remaining hex chars
        pattern = replaceAll(cs.pattern," ","/20");
        result = "Dragon constructor: CIDSS -> Dragon SUCCEED";
        success = true;
    }

    /*
    Constructor
    takes: Signature string
    aim: creates Dragon Signature object
    */
    public DragonSignature(String str){

        success = false;
        String[] splited;

        string = str;
        splited = string.split(" ");
        if(splited.length > 9){
            JOptionPane.showMessageDialog(
                null, "\n		Signature contains more than 9 words,\n       " +
                      "		so it won't be tranlsated corectly\n\n"+
                      "		Translation is limited to first 9 words\n\n\n", "WARNING",
                      JOptionPane.WARNING_MESSAGE);
            result = "Dragon constructor(str): Translation is limited to first 9 words";
        }

        if(splited.length < 9){
                JOptionPane.showMessageDialog(
                null, "\n		Signature contains less than 9 words,\n       ", "WARNING",
                      JOptionPane.WARNING_MESSAGE);
                result = "Dragon constructor(str): Signature contains less than 9 words. FAILED";
                for(int i=0; i<splited.length; i++){
                    System.out.println(splited[i]);
                }
                success = false;
                return;
        }

        // 0 protocol
        if(splited[0].equals("T") || splited[0].equals("U") || splited[0].equals("I"))
            protocol = splited[0].charAt(0);
                else{
            JOptionPane.showMessageDialog(
                null, "\nSorry, but Dragon doesn't know this language! "+
                                    "- Creating Dragon signature FAILED!", "WARNING",
                      JOptionPane.WARNING_MESSAGE);
            result = "Dragon constructor(str): Unknown protocol. FAILED";
            success = false;
            return;
        }

        // 1 port_direction
        if(splited[1].equals("D") || splited[1].equals("S") || splited[1].equals("A")|| splited[1].equals("B"))
            port_direction = splited[1].charAt(0);
        else{
            JOptionPane.showMessageDialog(
                null, "\nSorry, but Dragon doesn't know this language! "+
                                    "- Creating Dragon signature FAILED!", "WARNING",
                      JOptionPane.WARNING_MESSAGE);
            result = "Dragon constructor(str): Unknown port_direction. FAILED";
            success = false;
            return;
        }

        // 2 direction of the packet
        if(splited[2].equals("A") || splited[2].equals("T") || splited[2].equals("F") || splited[2].equals("I") || splited[2].equals("X") || splited[2].equals("D"))
            prot_net_direct = splited[2].charAt(0);
        else{
            JOptionPane.showMessageDialog(
                null, "\nSorry, but Dragon doesn't know this language! "+
                                    "- Creating Dragon signature FAILED!", "WARNING",
                      JOptionPane.WARNING_MESSAGE);
            result = "Dragon constructor(str): Unknown protocol network direction. FAILED";
            success = false;
            return;
        }


        // 3 pattern_type type
        if(splited[3].equals("B") || splited[3].equals("S")){
            pattern_type = splited[3].charAt(0);
        }
        else{
            JOptionPane.showMessageDialog(
                null, "\nSorry, but Dragon doesn't know this language! "+
                                    "- Creating Dragon signature FAILED!", "WARNING",
                      JOptionPane.WARNING_MESSAGE);
            result = "Dragon constructor(str): pattern_type type. FAILED";
            success = false;
            return;
        }

        // 4 log numbers logged after accident
        try{
            log_numbers = (new Integer(splited[4])).intValue();
        }
        catch(NumberFormatException e){
            JOptionPane.showMessageDialog(
                null, "\nSorry, but Dragon doesn't know this language! "+
                                    "- Creating Dragon signature FAILED!", "WARNING",
                      JOptionPane.WARNING_MESSAGE);
            result = "Dragon constructor(str): Unknown log_numbers. FAILED";
            success = false;
            return;
        }

        // 5 search_depth
        try{
            search_depth = (new Integer(splited[5])).intValue();
        }
        catch(NumberFormatException e){
            JOptionPane.showMessageDialog(
                null, "\nSorry, but Dragon doesn't know this language! "+
                                    "- Creating Dragon signature FAILED!", "WARNING",
                      JOptionPane.WARNING_MESSAGE);
            result = "Dragon constructor(str): Unknown search_depth. FAILED";
            success = false;
            return;
        }

        // 6 port numbers
        port_numbers = splited[6];   // what I'll tell you when alarm occurs
        name = splited[7];
        pattern = pattern_hex = splited[8]; 	//7 what are we searching for
        result = "Dragon constructor: string -> Dragon SUCCEED";
        success = true;
    }



    public CommonSignature toCommon(){

            String protoc 	= "";
            String sPort 	= "any";
            String dPort	= "any";
            boolean anyPort = false;
            String s_ip 		= "";
            boolean s_ip_neg 	= false;
            String d_ip 		= "";
            boolean d_ip_neg 	= false;
            boolean anyip		=false;
            String match_type = "";


        { /***************** protocol  *************/
                        String str[] = {"T","tcp","U","udp","I","icmp"};
                        protoc = switchChar(protocol, str);
        }


        { /****** source and destination ports (port direction)	****/
                        switch(port_direction){
                          case 'D':
                            dPort = port_numbers;
                            break;
                          case 'S':
                            sPort = port_numbers;
                            break;
                          case 'A':
                            sPort = port_numbers;
                            anyPort = true;
                            break;
                          case 'B':
                            sPort = port_numbers;
                            dPort = port_numbers;
                            break;
                          default: break;
                        }
        }


        { /********** ip directions   ****************/
                                switch(prot_net_direct){
                                  case 'A':
                                    s_ip = "any";
                                    d_ip = "any";
                                    anyip = true;
                                    break;
                                  case 'T':
                                    s_ip = "$EXTERNAL_NET";
                                    d_ip = "$HOME_NET";
                                    anyip = false;
                                    break;
                                  case 'F':
                                    s_ip = "$HOME_NET";
                                    d_ip = "$EXTERNAL_NET";
                                    anyip = false;
                                    break;
                                  case 'I':
                                    s_ip = "$HOME_NET";
                                    d_ip = "$HOME_NET";
                                    anyip = false;
                                    break;
                                  case 'X':
                                    s_ip = "$HOME_NET";
                                    d_ip = "$HOME_NET";
                                    anyip = false;
                                    d_ip_neg = true;
                                    s_ip_neg = true;
                                    break;
                                  default:// should be 'D'
                                    System.out.println("Unimplemented type. toCommon, Dragon. bye");
                                    result = "Dragon: Prot_net_direct = D not supported - FAILED";
                                    return null;
                                }
        }




        /******* pattern_type - done; pattern_type B-binary S -string ****/
        if(pattern_type == 'S')
            match_type = "string";
        else if(pattern_type == 'B')
            match_type = "hex";


        /******* text converting "/20" to spaces...... ********************/
        System.out.println(pattern);
		pattern = replaceAll(pattern,"/20"," ");
        System.out.println(pattern);

        /******* message converting "/20" to spaces...... ********************/
        System.out.println(name);
		name = replaceAll(name,"/20"," ");
        System.out.println("\""+name+"\"");

        result = "Dragon: toCommon() SUCCEED";
        success = true;
        return new CommonSignature("alert", protoc, "Dragon", "DragonSig",
                                    s_ip, s_ip_neg, d_ip, d_ip_neg,
                                    sPort, false, dPort, false,
                                    pattern, match_type, false, name,
                                    log_numbers, search_depth, "");
    }




    public String getDescribe(){
        String s = "";

        s += "\n\n----------------------------------------------------";
        s += "\nDRAGON Signature:";

        s += "\nprotocol:" + protocol;
        s += "\nport direction:" + port_direction;
        s += "\nprotected network direction: " + prot_net_direct;
        s += "\nMatching logic:" + pattern_type;
        s += "\nDynamic log:" + log_numbers;
        s += "\nSearch depth:" + search_depth;
        s += "\nPort number:" + port_numbers;
        s += "\nDescription:" + description;
        s += "\nMessage send after alarm (name):" + name;
        s += "\nString:" + pattern;
        s += "\nComment:" + "";

        s += "\n------------------------------------------------------\n";

        return s;
    }

    public String getSignature(){
        String string = "";
        string += protocol + " ";
        string += port_direction + " ";
        string += prot_net_direct + " ";
        string += pattern_type + " ";
        string += log_numbers + " ";
        string += search_depth + " ";
        string += port_numbers + " ";

        string += name + " ";
        string += pattern;
        return string;
    }
}
