package ids;

import org.w3c.dom.Document;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.DocumentBuilder;
import javax.swing.*;

public class XMLSignatures extends Parse{

    public XMLSignatures(){
    }

    public void addSignature(CommonSignature cs) {

        org.w3c.dom.Node node;
	node = document.getLastChild();

        org.w3c.dom.Element sig = document.createElement("SIGNATURE"),
            sigs = document.createElement("SIG_SOURCE"),
            desc = document.createElement("DESCRIPTION"),
            act  = document.createElement("ACTION"),
            prot = document.createElement("PROTOCOL"),
            sip  = document.createElement("SOURCE_IP"),
            sipn = document.createElement("SOURCE_IP_NEG"),
            sport = document.createElement("SOURCE_PORT"),
            sportn = document.createElement("SOURCE_PORT_NEG"),
            dip = document.createElement("DESTINATION_IP"),
            dipn = document.createElement("DESTINATION_IP_NEG"),
            dport = document.createElement("DESTINATION_PORT"),
            dportn = document.createElement("DESTINATION_PORT_NEG"),
            patttype = document.createElement("PATTERN_TYPE"),
            pattern = document.createElement("PATTERN_CONTENT"),
            pattneg = document.createElement("PATTERN_NEG"),
            logpack = document.createElement("LOGED_PACKETS"),
            search = document.createElement("SEARCH_DEPTH"),
            msg = document.createElement("MESSAGE"),
            comm = document.createElement("COMMENT");

        org.w3c.dom.Node addNode,
            shosts = document.createElement("SOURCE_HOSTS"),
            dhosts = document.createElement("DESTINATION_HOSTS"),
	    patt = document.createElement("PATTERN");

        sigs.appendChild(document.createTextNode(cs.sig_source));
        desc.appendChild(document.createTextNode(cs.description));
        act.appendChild(document.createTextNode(cs.action));
        prot.appendChild(document.createTextNode(cs.protocol));
        pattern.appendChild(document.createTextNode(cs.pattern));
        patttype.appendChild(document.createTextNode(cs.pattern_type));
        pattneg.appendChild(document.createTextNode(String.valueOf(cs.pattern_neg)));
        logpack.appendChild(document.createTextNode(String.valueOf(cs.loged_packets)));
        search.appendChild(document.createTextNode(String.valueOf(cs.search_depth)));
        msg.appendChild(document.createTextNode(cs.message));
        sip.appendChild(document.createTextNode(cs.source_ip));
        sipn.appendChild(document.createTextNode(String.valueOf(cs.source_ip_neg)));
        dip.appendChild(document.createTextNode(cs.destination_ip));
        dipn.appendChild(document.createTextNode(String.valueOf(cs.destination_ip_neg)));
		comm.appendChild(document.createTextNode(String.valueOf(cs.comment)));

        sport.appendChild(document.createTextNode(cs.source_port));
        sportn.appendChild(document.createTextNode(String.valueOf(cs.source_port_neg)));
        dport.appendChild(document.createTextNode(cs.destination_port));
        dportn.appendChild(document.createTextNode(String.valueOf(cs.destination_port_neg)));

        String id = JOptionPane.showInputDialog(
            null, "Please specify unique ID for a new signature");
        sig.setAttribute("ID", id);
        addNode = sig;

        // shosts node
        shosts.appendChild(sip);
        shosts.appendChild(sipn);
        shosts.appendChild(sport);
        shosts.appendChild(sportn);
        // dhosts node
        dhosts.appendChild(dip);
        dhosts.appendChild(dipn);
        dhosts.appendChild(dport);
        dhosts.appendChild(dportn);

		patt.appendChild(patttype);
		patt.appendChild(pattern);
		patt.appendChild(pattneg);
	    // signature node
	    addNode.appendChild(sigs);
	    addNode.appendChild(desc);
	    addNode.appendChild(act);
	    addNode.appendChild(prot);
	    addNode.appendChild(shosts);
	    addNode.appendChild(dhosts);
	    addNode.appendChild(patt);
        addNode.appendChild(msg);
	    addNode.appendChild(logpack);
        addNode.appendChild(search);
        addNode.appendChild(comm);

		System.out.println("1:"+node);
		System.out.println("2:"+addNode);
	    node.appendChild(addNode);
        DomToTreeModelAdapter dttma = new DomToTreeModelAdapter();
        JTree tree = new JTree(dttma);
		DataGui.setTree(tree);
    }
    public void removeSignature(){
	JTree tree = DataGui.getTree();
        if(tree == null || tree.getSelectionPath() == null)
            return;

        String path = tree.getSelectionPath().toString();
        String attrVal;
        org.w3c.dom.NodeList nList;
        org.w3c.dom.Node node = null;
        org.w3c.dom.NodeList nodeList;

        if(path.length() < 52)
            return;

        if(path.substring(0, 51).equals("[Document, Element: SIGNATURES, Element: SIGNATURE "))
            attrVal = path.substring(51, path.length()-1);
        else
            return;

        nList= document.getElementsByTagName("SIGNATURE");
        for(int i=0; i<nList.getLength(); i++){
            if(nList.item(i).getAttributes().item(0).getNodeValue().equals(attrVal)){
                node = nList.item(i);
                break;
            }
            else if(i == nList.getLength()-1)
                return;
        }

        document.getFirstChild().removeChild(node);
        DomToTreeModelAdapter dttma = new DomToTreeModelAdapter();
        tree = new JTree(dttma);
	DataGui.setTree(tree);
    }

    public CommonSignature dataToCommmon(){
	JTree tree = DataGui.getTree();
        if(tree == null || tree.getSelectionPath() == null)
            return null;
        String path = tree.getSelectionPath().toString();
        String attrVal;
        org.w3c.dom.NodeList nList;
        org.w3c.dom.Node node = null;
        org.w3c.dom.NodeList nodeList;
        org.w3c.dom.NodeList nodeItem;
        org.w3c.dom.NodeList nodeSHosts;
        org.w3c.dom.NodeList nodeDHosts;
        org.w3c.dom.NodeList nodePatt;

        String sig_source = "unknown";
        String description = "";
        String action = "unknown";
        String protocol = "unknown";

        String source_ip = "unknown";
        boolean source_ip_neg = false;
        String source_port = "unknown";
        boolean source_port_neg = false;
        String destination_ip = "unknown";
        boolean destination_ip_neg = false;
        String destination_port = "unknown";
        boolean destination_port_neg = false;

        String pattern = "";
        String pattern_type = "unknown";
        boolean pattern_neg = false;
        String message = "";
        int loged_packets = 0;
        int search_depth = 0;
        String comment = "";

        if(tree.getSelectionPath() == null || tree.getSelectionPath().toString().length() < 52)
            return null;
        if(path.substring(0, 51).equals("[Document, Element: SIGNATURES, Element: SIGNATURE "))
            attrVal = path.substring(51, path.length()-1);
        else
            return null;
        nList= document.getElementsByTagName("SIGNATURE");
        for(int i=0; i<nList.getLength(); i++){
            if(nList.item(i).getAttributes().item(0).getNodeValue().equals(attrVal)){
                node = nList.item(i);
                break;
                }
            else if(i == nList.getLength()-1)
                return null;
        }

        nodeList = node.getChildNodes();
        for(int i=0; i<nodeList.getLength(); i++) {
          String name = nodeList.item(i).getNodeName();
          if(name.equalsIgnoreCase("Sig_Source") && nodeList.item(i).getFirstChild()!=null) {
            sig_source = nodeList.item(i).getFirstChild().getNodeValue();
          } else if (name.equalsIgnoreCase("Description") && nodeList.item(i).getFirstChild()!=null) {
            description = nodeList.item(i).getFirstChild().getNodeValue();
          } else if (name.equalsIgnoreCase("Action") && nodeList.item(i).getFirstChild()!=null) {
            action = nodeList.item(i).getFirstChild().getNodeValue();
          } else if (name.equalsIgnoreCase("Protocol") && nodeList.item(i).getFirstChild()!=null) {
            protocol = nodeList.item(i).getFirstChild().getNodeValue();
          } else if (name.equalsIgnoreCase("Message") && nodeList.item(i).getFirstChild()!=null) {
            message = nodeList.item(i).getFirstChild().getNodeValue();
          } else if (name.equalsIgnoreCase("Loged_Packets") && nodeList.item(i).getFirstChild()!=null) {
            loged_packets = Integer.parseInt(nodeList.item(i).getFirstChild().getNodeValue());
          } else if (name.equalsIgnoreCase("Search_Depth") && nodeList.item(i).getFirstChild()!=null) {
            search_depth = Integer.parseInt(nodeList.item(i).getFirstChild().getNodeValue());
          } else if (name.equalsIgnoreCase("Comment") && nodeList.item(i).getFirstChild()!=null) {
            comment = nodeList.item(i).getFirstChild().getNodeValue();
          } else if (name.equalsIgnoreCase("Source_Hosts")) {
            nodeSHosts = nodeList.item(i).getChildNodes();
            for(int j=0; j<nodeSHosts.getLength(); j++) {
              String sourceName = nodeSHosts.item(j).getNodeName();
              if (sourceName.equalsIgnoreCase("Source_IP")) {
                source_ip = nodeSHosts.item(j).getFirstChild().getNodeValue();
              } else if (sourceName.equalsIgnoreCase("Source_IP_neg")) {
                source_ip_neg = Boolean.getBoolean(nodeSHosts.item(j).getFirstChild().getNodeValue());
              } else if (sourceName.equalsIgnoreCase("Source_Port")) {
                source_port = nodeSHosts.item(j).getFirstChild().getNodeValue();
              } else if (sourceName.equalsIgnoreCase("Source_Port_neg")) {
                source_port_neg = Boolean.getBoolean(nodeSHosts.item(j).getFirstChild().getNodeValue());
              }
            }
          } else if (name.equalsIgnoreCase("Destination_Hosts")) {
            nodeDHosts = nodeList.item(i).getChildNodes();
            for(int j=0; j<nodeDHosts.getLength(); j++) {
              String destName = nodeDHosts.item(j).getNodeName();
              if (destName.equalsIgnoreCase("Destination_IP")) {
                destination_ip = nodeDHosts.item(j).getFirstChild().getNodeValue();
              } else if (destName.equalsIgnoreCase("Destination_IP_neg")) {
                destination_ip_neg = Boolean.getBoolean(nodeDHosts.item(j).getFirstChild().getNodeValue());
              } else if (destName.equalsIgnoreCase("Destination_Port")) {
                destination_port = nodeDHosts.item(j).getFirstChild().getNodeValue();
              } else if (destName.equalsIgnoreCase("Destination_Port_neg")) {
              destination_port_neg = Boolean.getBoolean(nodeDHosts.item(j).getFirstChild().getNodeValue());
            }
          }
        } else if (name.equalsIgnoreCase("Pattern")) {
          nodePatt = nodeList.item(i).getChildNodes();
          for(int j=0; j<nodePatt.getLength(); j++) {
            String pattName = nodePatt.item(j).getNodeName();
            if (pattName.equalsIgnoreCase("Pattern_Type")) {
              pattern_type = nodePatt.item(j).getFirstChild().getNodeValue();
            } else if (pattName.equalsIgnoreCase("Pattern_Content")) {
              pattern = nodePatt.item(j).getFirstChild().getNodeValue();
            } else if (pattName.equalsIgnoreCase("Pattern_Neg")) {
              pattern_neg = Boolean.getBoolean(nodePatt.item(j).getFirstChild().getNodeValue());
            }
          }
        }
      }

        return new CommonSignature(action,protocol,sig_source,description,
                        source_ip, source_ip_neg, destination_ip, destination_ip_neg,
                        source_port, source_port_neg, destination_port,destination_port_neg,
                        pattern, pattern_type, pattern_neg, message,
                        loged_packets, search_depth, comment);
    }
}
